# - *- coding: utf- 8 - *-
from Plugins.Plugin import PluginDescriptor
from .TVSViewer import TVSViewer
from enigma import addFont
from Screens.InfoBarGenerics import SecondInfoBar
from Screens.InfoBar import MoviePlayer
from ServiceReference import ServiceReference
from Components.config import config, fileExists
from Components.ActionMap import ActionMap
from functools import partial
import os

from .TVSViewerConfig import pluginPath, writeLog, enableLogging, logFile

addFont(pluginPath + "/fonts/MyriadPro-Regular.otf", "TVSVFont", 93, False)
addFont(pluginPath + "/fonts/Muli-Regular.ttf", "TVSVFontDesc", 90, False)
addFont(pluginPath + "/fonts/MyriadPro-Semibold.otf", "TVSVFontBold", 93, False)
addFont(pluginPath + "/fonts/MyriadPro-SemiboldIt.otf", "TVSVFontItalic", 93, False)

orgMoviePlayerInit = None

def main(session, **kwargs):
	session.open(TVSViewer)
	
def movieList(session, service, **kwargs):
	if service:
		sRef = ServiceReference(service)
		if sRef and sRef.getType() != 2:
			session.open(TVSViewer,None,ServiceReference(service),"MovieList")
	
def sessionstart(reason, **kwargs):
	if reason == 0:		
		#========== Logging ============
		if config.plugins.TVSViewer.logging.value:
			if fileExists(logFile): 
				os.remove(logFile)
			enableLogging()
			
		#========== asSIB =============
		if config.plugins.TVSViewer.asSIB.value:
			SecondInfoBar.show = newSIBShow
		
		#==== TVS-Viewer with KeyGreen in MoviePlayer ====
		if config.plugins.TVSViewer.moviePlayerKeyGreen.value:
			global orgMoviePlayerInit
			if orgMoviePlayerInit is None:
				orgMoviePlayerInit = MoviePlayer.__init__
				MoviePlayer.__init__ = newMoviePlayerInit
		
def newSIBShow(self):
	self.hide()
	self.session.open(TVSViewer)
	
def moviePlayerGreen(self):
	self.session.open(TVSViewer)
	return 1

def dummy(self):
	return 1
	
def newMoviePlayerInit(self, session, service):
	self["myActions"] = ActionMap(["TVSViewerActions_MoviePlayer"],
		{
			"key_green_down": partial(dummy,self),
			"key_green_up": partial(moviePlayerGreen,self),
			"key_green_long": self.setPlayMode
		}, -2)
	orgMoviePlayerInit(self, session, service)
	
#========== Plugin-Init =============	
def Plugins(**kwargs):
	return [
	PluginDescriptor(
		name = _("TV-Spielfilm-Viewer"), 
		description = _("TV-Spielfilm-Viewer"),
		where = PluginDescriptor.WHERE_PLUGINMENU,
		icon = "TVS-Viewer.png",
		fnc = main
	),
	PluginDescriptor(
		name = _("TV-Spielfilm-Viewer"), 
		description = _("TVS-Viewer"),
		where = PluginDescriptor.WHERE_MOVIELIST,
		fnc = movieList
	),
	PluginDescriptor(
		name = "TV-Spielfilm-Viewer", 
		where = PluginDescriptor.WHERE_SESSIONSTART,
		fnc = sessionstart
	)
	]
